<?php

namespace Drupal\path_watcher\Plugin\views\argument_default;

use Drupal\Core\Cache\Cache;
use Drupal\Core\Cache\CacheableDependencyInterface;
use Drupal\views\Plugin\views\argument_default\ArgumentDefaultPluginBase;

/**
 * Default argument plugin to extract the current path hash.
 *
 * @ViewsArgumentDefault(
 *   id = "path_watcher_hash",
 *   title = @Translation("Path watcher hash")
 * )
 */
class PathWatcherHash extends ArgumentDefaultPluginBase implements CacheableDependencyInterface {

  /**
   * {@inheritdoc}
   */
  public function getArgument() {
    $path = \Drupal::request()->getPathInfo();
    return \Drupal::service('path_watcher.manager')->getPathHash($path);
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheMaxAge() {
    return Cache::PERMANENT;
  }

  /**
   * {@inheritdoc}
   */
  public function getCacheContexts() {
    return ['url.path'];
  }

}
